'
'  ADDITEM.BAS
'
'  Add Item Memory Share'
'  by Don Dickinson, Oct. 1997
'
'  Purpose:
'
'  This program needs to be compiled as a console application
'  under PB 5. Once compiled, please mark it as a console
'  application with MKCON.EXE (Download CONSOLE.ZIP from
'  PB's web site or compuserve forum to rebuild.
'
'  Created using the sample application from PowerBasic (CONSOLE.ZIP)
'  as a template.
'
$DIM ALL
$COMPILE EXE
$INCLUDE "WIN32API.INC"

%ADD_LISTITEM = 100

'%STD_INPUT_HANDLE  = -10&
'%STD_OUTPUT_HANDLE = -11&
'
'TYPE OVERLAPPED
'  Internal AS LONG
'  InternalHigh AS LONG
'  offset AS LONG
'  OffsetHigh AS LONG
'  hEvent AS LONG
'END TYPE
'
'DECLARE FUNCTION GetStdHandle LIB "KERNEL32.DLL" ALIAS "GetStdHandle" (BYVAL nStdHandle AS LONG) AS LONG
'DECLARE FUNCTION WriteConsole LIB "KERNEL32.DLL" ALIAS "WriteConsoleA" (BYVAL hConsoleOutput AS LONG, lpBuffer AS ASCIIZ, BYVAL nNumberOfCharsToWrite AS LONG, lpNumberOfCharsWritten AS LONG, BYVAL lpReserved AS LONG) AS LONG
'DECLARE FUNCTION ReadFile LIB "KERNEL32.DLL" ALIAS "ReadFile" (BYVAL hFile AS LONG, lpBuffer AS ANY, BYVAL nNumberOfBytesToRead AS LONG, lpNumberOfBytesRead AS LONG, lpOverlapped AS OVERLAPPED) AS LONG
'DECLARE FUNCTION SetConsoleMode LIB "KERNEL32.DLL" ALIAS "SetConsoleMode" (BYVAL hConsoleHandle AS LONG, BYVAL dwMode AS LONG) AS LONG

GLOBAL hOutput AS LONG
GLOBAL hInput AS LONG

'
'  StdOut
'
SUB StdOut(BYVAL x AS STRING)

  LOCAL Buffer  AS LONG
  LOCAL Written AS LONG

  Buffer = STRPTR(x)
  WriteConsole hOutput, BYVAL Buffer, LEN(x), Written, %NULL

END SUB

'
'  StdOutLn
'
SUB StdOutLn(BYVAL x AS STRING)
  StdOut x & CHR$(13,10)
END SUB


'
'  WinMain
'
FUNCTION WinMain (BYVAL CurInst&, _
                  BYVAL PrvInst&, _
                  CmdLine AS ASCIIZ PTR, _
                   BYVAL CmdShow&) EXPORT AS LONG

   Dim i as String
   Dim hOtherWindow as Long
   Dim rSendData as COPYDATASTRUCT
   Dim zString as ASCIIZ * 200

   hOutput = GetStdHandle(%STD_OUTPUT_HANDLE)
   hInput  = GetStdHandle(%STD_INPUT_HANDLE)
  
   hOtherWindow = FindWindow("Test_WM_COPYDATA", "")

   SetConsoleMode hInput, %NULL
  
   StdOutLn ""
   StdOutLn "    ========================================="
   StdOutLn "    Sample Memory Sharing via WM_COPYDATA"
   StdOutLn "    Created with PB/DLL 5.0 for Windows 95/NT"
   StdOutLn "    Created By Don Dickinson, Oct. 1997"
   StdOutLn "    ========================================="
   StdOutLn ""
   if trim$(COMMAND$) = "" then
      StdOutLn "    Usage: ADDITEM <item text>"
      StdOutLn "    Param: <item text> is the text that"
      StdOutLn "           is to be added to the list"
      StdOutLn "           in the memtest.exe program"
      StdOutLn "    Notes: memtest.exe should be running"
      StdOutLn "           before executing this program"
   elseif hOtherWindow = 0 then
      StdOutLn "    Please make sure that memtest.exe is"
      StdOutLn "    running. This program needs to get"
      StdOutLn "    it's window handle (via class name)"
      StdOutLn "    in order to function"
   else
      zString = trim$(COMMAND$)
      rSendData.dwData = %ADD_LISTITEM
      rSendData.cbData = len(zString) + 1
      rSendData.lpData = VARPTR(zString)
      SendMessage hOtherWindow, %WM_COPYDATA, 0, VARPTR(rSendData)
      StdOutLn "    Message Sent to add items"
   end if

   StdOutLn "    ========================================="

END FUNCTION
